// ==========================================================================
// Copyright (C) 1995 - 2006 Autodesk, Inc. and/or its licensors.  All 
// rights reserved.
//
// The coded instructions, statements, computer programs, and/or related 
// material (collectively the "Data") in these files contain unpublished 
// information proprietary to Autodesk, Inc. ("Autodesk") and/or its 
// licensors, which is protected by U.S. and Canadian federal copyright 
// law and by international treaties.
//
// The Data is provided for use exclusively by You. You have the right 
// to use, modify, and incorporate this Data into other products for 
// purposes authorized by the Autodesk software license agreement, 
// without fee.
//
// The copyright notices in the Software and this entire statement, 
// including the above license grant, this restriction and the 
// following disclaimer, must be included in all copies of the 
// Software, in whole or in part, and all derivative works of 
// the Software, unless such copies or derivative works are solely 
// in the form of machine-executable object code generated by a 
// source language processor.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND. 
// AUTODESK DOES NOT MAKE AND HEREBY DISCLAIMS ANY EXPRESS OR IMPLIED 
// WARRANTIES INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
// NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
// PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE, OR 
// TRADE PRACTICE. IN NO EVENT WILL AUTODESK AND/OR ITS LICENSORS 
// BE LIABLE FOR ANY LOST REVENUES, DATA, OR PROFITS, OR SPECIAL, 
// DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES, EVEN IF AUTODESK 
// AND/OR ITS LICENSORS HAS BEEN ADVISED OF THE POSSIBILITY 
// OR PROBABILITY OF SUCH DAMAGES.
//
// ==========================================================================

var MWTObject = null
var MWTPortName = null
var MWTUseCOM = false
var MWTUseAlerts = false

function MWT_Connect(PortName) 
{
	if(MWTObject != null) {
		if(MWTUseCOM) {
			MWTObject.PortName = PortName;
			MWTObject.Connect()
		} else {
			MWTObject.port = PortName
		} 
	} else {
		if(MWTUseAlerts) alert('No plugin object found.')
	}
}

function MWT_Embed(PluginName, PortName)
{
	// Detect if we want to use COM object instead of plugin...
	Agent = navigator.userAgent.toLowerCase();
	var isWindows = false
	// ... is this Windows?
	if((Agent.indexOf("win") != -1) || (Agent.indexOf("16bit") != -1))
	{
		isWindows = true
		// ... is this Internet Explorer?
		if(Agent.indexOf("msie") != -1) {
			// ... then use COM
			MWTUseCOM = true;
		}
	}

	// Now, determine if plugin/COM object is available
	if(MWTUseCOM) {
		// With IE we do nothing here. If COM object is not registered, or ActiveX disabled,
		// ActiveXObject() call will return null. 
	} else {
		var plugin = (isWindows) ? "MCP PlugIn" : "MCP Plug-In"
		var found = false, enabled = false
		for(var i = 0; !found && i < navigator.plugins.length; i++){
			if(navigator.plugins[i].name.toLowerCase() == plugin.toLowerCase()){ 
				found = true
				for (var j = 0; !enabled && j < navigator.plugins[i].length; j++){
					if(navigator.plugins[i][j].enabledPlugin) {
						enabled = true // We are OK
					}
				}
				if(!enabled) {
					if(MWTUseAlerts) alert('MCP Plug-in is installed, but disabled')
					return // Cannot continue
				}
			}
		}
		if(!found) {
			if(MWTUseAlerts) alert('MCP Plug-in is not installed')
			return // Cannot continue
		}
	}

	MWTPortName = PortName
	if(MWTUseCOM) {
		MWTObject = new ActiveXObject("Maya.CommandEngine.MEL")
	} else {
		MWTObject = document.createElement('embed')
		MWTObject.setAttribute('name', PluginName)
		MWTObject.setAttribute('type', 'application/x-mcp')
		MWTObject.setAttribute('hidden', 'true')
		document.body.appendChild(MWTObject)
	}
}

function MWT_Execute(CommandText)
{
	if(MWTObject != null) {
		if(MWTPortName != null) {
			if(MWTUseCOM) {
				if(MWTPortName != MWTObject.PortName) {
					MWTObject.PortName = MWTPortName
				}
				MWTObject.Execute(CommandText)
				return MWTObject.Result
			} else {
                            try {
				if(MWTPortName != MWTObject.port) {
					MWTObject.port = MWTPortName
				}
				return MWTObject.execute(CommandText)
                            } catch(e) {
                                var response = confirm("Maya has lost connection with Tactic.  Reload this page?")
                                if (response == true)
                                    document.form.submit()
                                throw(e)
                            }
			}
		} else {
			if(MWTUseAlerts) alert('Cannot connect to undefined port name.')
			return null
		}
	} else {
		if(MWTUseAlerts) alert('No plugin object found.')
		return null
	}
}

function MWT_PositionBrowser(side, size)
{
	browserleft = 0; browsertop = 0; 
	mayabrowserleft = 0; mayabrowsertop = 0; 
	browserwidth = screen.availWidth; 
	browserbrowserheight = screen.availHeight;
	mayabrowserwidth = screen.availWidth; 
	mayabrowserbrowserheight = screen.availHeight;
	
	switch(side) {
		case 'left':
			browserwidth = Math.round(screen.availWidth/100*size);
			mayabrowserleft = browserwidth + 1;
			mayabrowserwidth = screen.availWidth - browserwidth - 1;
		break;
		case 'right':
			browserwidth = Math.round(screen.availWidth/100*size);
			browserleft = screen.availWidth - browserwidth;
			mayabrowserwidth = screen.availWidth - browserwidth - 1;
		break;
		case 'top':
			browserbrowserheight = Math.round(screen.availHeight/100*size);
			mayabrowsertop = browserbrowserheight + 1;
			mayabrowserbrowserheight = screen.availHeight - browserbrowserheight - 1;
		break;
		case 'bottom':
			browserbrowserheight = Math.round(screen.availHeight/100*size);
			browsertop = screen.availHeight - browserbrowserheight;
			mayabrowserbrowserheight = screen.availHeight - browserbrowserheight - 1;
		break;
	}

	if(MWTUseCOM) {
		window.top.moveTo(browserleft, browsertop);
		window.top.resizeTo(browserwidth, browserbrowserheight);
	} else {
		window.top.moveTo(0,0);
		window.top.resizeTo(browserwidth, browserbrowserheight);
		window.top.moveTo(browserleft, browsertop+screenY);
	}	
	var CmdText = "window -e -tlc " + mayabrowsertop + " " + mayabrowserleft + " -wh " + mayabrowserwidth + " " + mayabrowserbrowserheight + " MayaWindow"
	MWT_Execute(CmdText)
}
